/*
 * Code for class I18N_UNIX_C_FUNCTIONS
 */

#include "eif_eiffel.h"
#include "../E1/estructure.h"
#include "../E1/eoffsets.h"

#include "i1156.h"
#include <string.h>
#include <eif_langinfo.h>
#include <iconv.h>
#include <locale.h>

#ifdef __cplusplus
extern "C" {
#endif

#ifndef INLINE_F188_3155
static EIF_INTEGER_32 inline_F188_3155 (void)
{
	return LC_ALL;
	;
}
#define INLINE_F188_3155
#endif
#ifndef INLINE_F188_3154
static EIF_POINTER inline_F188_3154 (EIF_INTEGER_32 arg1, EIF_POINTER arg2)
{
	return setlocale((int) arg1, (const char *) arg2);
	;
}
#define INLINE_F188_3154
#endif
#ifndef INLINE_F188_3149
static EIF_POINTER inline_F188_3149 (EIF_INTEGER_32 arg1)
{
	char *dname;
				wchar_t *out = NULL;
				size_t insize, outsize = 0;

				dname = nl_langinfo(arg1);
				insize = strlen(dname) + 1;
				
				{
					iconv_t cd;
					size_t nconv, avail, alloc;
					char *res, *tres, *wrptr, *inptr;

					alloc = avail = insize + insize/4;
					if (!(res = malloc(alloc))) {
					  perror("malloc");
					  return NULL;
					}

					wrptr = res;   /* duplicate pointers because they */
					inptr = dname; /* get modified by iconv */
					
					/*get charset used by current locale */
					#if EIF_OS == EIF_OS_OPENBSD
						char *charset = locale_charset ();
					#else
						char *charset = nl_langinfo (CODESET);
					#endif
					
					cd = iconv_open ("UTF-8", charset);
					if (cd == (iconv_t)(-1)) {
							perror("iconv_open");
							free(res);
							return NULL;
					}

					do {
							nconv = iconv (cd, (const char **) &inptr, &insize, &wrptr, &avail); /*convertions */
							if (nconv == (size_t)(-1)) {
									if (errno == E2BIG) { /* need more room for result */
											tres = realloc(res, alloc += 20);
											avail += 20;
											if (!tres) {
													perror("realloc");
													break;
											}
											wrptr = tres + (wrptr - res);
											res = tres;
									}
									else /* something wrong with input */
											break;
							}
					} while (insize);

					if (iconv_close(cd))
							perror("iconv_close");
				   
					out = (wchar_t*) res;
					outsize = wrptr - res; /* should be == to (alloc - avail + 1) */
					/* TODO: should possibly null-terminate the result */
				}
				return out;
	;
}
#define INLINE_F188_3149
#endif
#ifndef INLINE_F188_3151
static EIF_POINTER inline_F188_3151 (void)
{
	#if EIF_OS == EIF_OS_OPENBSD
	return locale_charset ();
#else
	return nl_langinfo (CODESET);
#endif
	;
}
#define INLINE_F188_3151
#endif

#ifdef __cplusplus
}
#endif


#ifdef __cplusplus
extern "C" {
#endif

/* {I18N_UNIX_C_FUNCTIONS}.unix_set_locale */
void F188_3147 (EIF_REFERENCE Current, EIF_REFERENCE arg1)
{
	GTCX
	EIF_REFERENCE loc1 = (EIF_REFERENCE) 0;
	EIF_POINTER loc2 = (EIF_POINTER) 0;
	EIF_POINTER loc3 = (EIF_POINTER) 0;
	EIF_POINTER tp1;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	EIF_INTEGER_32 ti4_1;
	RTLD;
	
	RTLI(5);
	RTLR(0,loc1);
	RTLR(1,tr1);
	RTLR(2,arg1);
	RTLR(3,Current);
	RTLR(4,tr2);
	
	RTGC;
	tr1 = RTLNS(1312, 1312, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F1313_12528(RTCV(tr1), arg1);
	loc1 = (EIF_REFERENCE) tr1;
	ti4_1 = inline_F188_3155();
	{
	/* INLINED CODE (item) */
	tp1 = (EIF_POINTER)  0;
	tr1 = *(EIF_REFERENCE *)(RTCV(loc1));
	tp1 = *(EIF_POINTER *)(RTCV(tr1)+ _PTROFF_0_1_0_1_0_0_);
	/* END INLINED CODE */
	}
	tp1 = tp1;
	loc2 = inline_F188_3154(ti4_1, tp1);
	if ((EIF_BOOLEAN)(loc2 != loc3)) {
		tr1 = RTLNS(1312, 1312, _OBJSIZ_1_0_0_1_0_0_0_0_);
		F1313_12532(RTCV(tr1), loc2);
		loc1 = (EIF_REFERENCE) tr1;
		tr1 = RTOSCF(3153,F188_3153,(Current));
		{
		/* INLINED CODE (string) */
		tr2 = (EIF_REFERENCE)  0;
		tp1 = F1313_12547(RTCV(loc1));
		ti4_1 = (EIF_INTEGER_32) strlen((char*) tp1);
		tr2 = F1313_12540(RTCV(loc1), ((EIF_INTEGER_32) 1L), ti4_1);
		/* END INLINED CODE */
		}
		tr2 = tr2;
		F417_6464(RTCV(tr1), tr2);
	} else {
		tr1 = RTOSCF(3153,F188_3153,(Current));
		tr2 = RTMS_EX_H("POSIX",5,1331472728);
		F417_6464(RTCV(tr1), tr2);
	}
	RTLE;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_get_locale_info_managed */
EIF_REFERENCE F188_3148 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	EIF_POINTER tp1;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE Result = ((EIF_REFERENCE) 0);
	
	RTLD;
	
	RTLI(2);
	RTLR(0,tr1);
	RTLR(1,Result);
	
	RTGC;
	tr1 = RTLNS(980, 980, _OBJSIZ_0_1_0_1_0_1_1_0_);
	tp1 = inline_F188_3149(arg1);
	F981_10105(RTCV(tr1), tp1, ((EIF_INTEGER_32) 0L));
	Result = (EIF_REFERENCE) tr1;
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_get_locale_info */
EIF_POINTER F188_3149 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F188_3149 ((EIF_INTEGER_32) arg1);
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_is_available */
EIF_BOOLEAN F188_3150 (EIF_REFERENCE Current, EIF_REFERENCE arg1)
{
	GTCX
	EIF_REFERENCE loc1 = (EIF_REFERENCE) 0;
	EIF_POINTER loc2 = (EIF_POINTER) 0;
	EIF_POINTER tp1;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	EIF_INTEGER_32 ti4_1;
	EIF_BOOLEAN Result = ((EIF_BOOLEAN) 0);
	
	RTLD;
	
	RTLI(5);
	RTLR(0,loc1);
	RTLR(1,tr1);
	RTLR(2,arg1);
	RTLR(3,Current);
	RTLR(4,tr2);
	
	RTGC;
	tr1 = RTLNS(1312, 1312, _OBJSIZ_1_0_0_1_0_0_0_0_);
	F1313_12528(RTCV(tr1), arg1);
	loc1 = (EIF_REFERENCE) tr1;
	ti4_1 = inline_F188_3155();
	{
	/* INLINED CODE (item) */
	tp1 = (EIF_POINTER)  0;
	tr1 = *(EIF_REFERENCE *)(RTCV(loc1));
	tp1 = *(EIF_POINTER *)(RTCV(tr1)+ _PTROFF_0_1_0_1_0_0_);
	/* END INLINED CODE */
	}
	tp1 = tp1;
	tp1 = inline_F188_3154(ti4_1, tp1);
	Result = (EIF_BOOLEAN) (EIF_BOOLEAN)(tp1 != loc2);
	{
	/* INLINED CODE (unix_locale_name) */
	tr1 = (EIF_REFERENCE)  0;
	tr1 = RTOSCF(3153,F188_3153,(RTCV(Current)));
	tr1 = F417_6463(RTCV(tr1));
	/* END INLINED CODE */
	}
	tr2 = tr1;
	F188_3147(Current, tr2);
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.c_current_codeset */
EIF_POINTER F188_3151 (EIF_REFERENCE Current)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F188_3151 ();
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_locale_name */
EIF_REFERENCE F188_3152 (EIF_REFERENCE Current)
{
	GTCX
	EIF_REFERENCE Result = ((EIF_REFERENCE) 0);
	
	RTLD;
	
	RTLI(2);
	RTLR(0,Current);
	RTLR(1,Result);
	
	RTGC;
	Result = *(EIF_REFERENCE *)(RTCV(RTOSCF(3153,F188_3153,(Current))));
	RTLE;
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.unix_locale_name_cell */
static EIF_REFERENCE F188_3153_body (EIF_REFERENCE Current)
{
	GTCX
	RTEX;
	EIF_REFERENCE tr1 = NULL;
	EIF_REFERENCE tr2 = NULL;
	RTLD;
	

	RTLI(3);
	RTLR(0,Current);
	RTLR(1,tr1);
	RTLR(2,tr2);
	
	RTEV;
	RTGC;
	RTOSP (3153);
#define Result RTOSR(3153)
	RTOC_NEW(Result);
	{
		static EIF_TYPE_INDEX typarr0[] = {187,416,1837,0xFFFF};
		EIF_TYPE_INDEX typres0;
		static EIF_TYPE_INDEX typcache0 = INVALID_DTYPE;
		
		typres0 = (typcache0 != INVALID_DTYPE ? typcache0 : (typcache0 = eif_compound_id(Dftype(Current), 416, typarr0)));
		tr1 = RTLNS(typres0, 416, _OBJSIZ_1_0_0_0_0_0_0_0_);
	}
	tr2 = RTMS_EX_H("POSIX",5,1331472728);
	F417_6464(RTCV(tr1), tr2);
	Result = (EIF_REFERENCE) tr1;
	RTOSE (3153);
	RTLE;
	RTEE;
	return Result;
#undef Result
}

EIF_REFERENCE F188_3153 (EIF_REFERENCE Current)
{
	GTCX
	return RTOSCF(3153,F188_3153_body,(Current));
}

/* {I18N_UNIX_C_FUNCTIONS}.c_setlocale */
EIF_POINTER F188_3154 (EIF_REFERENCE Current, EIF_INTEGER_32 arg1, EIF_POINTER arg2)
{
	GTCX
	EIF_POINTER Result = ((EIF_POINTER) 0);
	
	
	
	Result = inline_F188_3154 ((EIF_INTEGER_32) arg1, (EIF_POINTER) arg2);
	return Result;
}

/* {I18N_UNIX_C_FUNCTIONS}.c_lc_all */
EIF_INTEGER_32 F188_3155 (EIF_REFERENCE Current)
{
	GTCX
	EIF_INTEGER_32 Result = ((EIF_INTEGER_32) 0);
	
	
	
	Result = inline_F188_3155 ();
	return Result;
}

void EIF_Minit156 (void)
{
	GTCX
}


#ifdef __cplusplus
}
#endif
